/*******************************************************************************
 *  Copyright 2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.dcm30_04.templates.cid;


import cdac.medinfo.sdk.dcm30_04.templates.enums.EnumCodingSchemeDesignator;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_IOLCalculationFormula;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cv.EnumCV_IOLCalculationFormula;


/**
 * This class represents IOLCalculationFormula - CID4236
 */
public class IOLCalculationFormula_CID4236 
{
	
	/**
	 * The Code Value for template.
	 */
	private String strCodeValue = null;

	/**
	 * The Code Meaning for template.
	 */
	private String strCodeMeaning = null;

	/**
	 * The Coding Scheme Designator for template.
	 */
	private String strCodingSchemeDesignator;

	/**
	 * Instantiates a new IOLCalculationFormula_CID4236 Template 
	 */
	public IOLCalculationFormula_CID4236()
	{

	}

	/**
	 * Retrieves the value for Code Meaning.
	 * @return String value for Code Meaning.
	 */
	public String getCodeMeaning()
	{
		return strCodeMeaning;
	}

	/**
	 * Retrieves the value for Code Value.
	 * @return String value for Code Value.
	 */
	public String getCodeValue() 
	{
		return strCodeValue;
	}

	/**
	 * Retrieves the value for Coding Scheme Designator.
	 * @return String value for Coding Scheme Designator.
	 */
	public String getCodingSchemeDesignator() 
	{
		return strCodingSchemeDesignator;
	}

	/**
	 * Sets the Code Value according to Code Meaning.
	 * @param enumIOLCalculationFormula Object of EnumCM_IOLCalculationFormula represents Code Meaning.
	 */
	private void setCodeValue(EnumCM_IOLCalculationFormula enumIOLCalculationFormula)
	{
		switch(enumIOLCalculationFormula)
		{
		case HAIGIS: this.strCodeValue =EnumCV_IOLCalculationFormula.HAIGIS_111760.getValue(); break;
		case HAIGIS_L: this.strCodeValue =EnumCV_IOLCalculationFormula.HAIGIS_L_111761.getValue(); break;
		case HOLLADAY_1: this.strCodeValue =EnumCV_IOLCalculationFormula.HOLLADAY_1_111762.getValue(); break;
		case HOLLADAY_2: this.strCodeValue =EnumCV_IOLCalculationFormula.HOLLADAY_2_111763.getValue(); break;
		case HOFFER_Q: this.strCodeValue =EnumCV_IOLCalculationFormula.HOFFER_Q_111764.getValue(); break;
		case OLSEN: this.strCodeValue =EnumCV_IOLCalculationFormula.OLSEN_111765.getValue(); break;
		case SRKII: this.strCodeValue =EnumCV_IOLCalculationFormula.SRKII_111766.getValue(); break;
		case SRK_T: this.strCodeValue =EnumCV_IOLCalculationFormula.SRK_T_111767.getValue(); break;
		}
	}

	/**
	 * Sets the value for IOLCalculationFormula
	 * @param enumIOLCalculationFormula Object of EnumCM_IOLCalculationFormula.
	 */
	public void setIOLCalculationFormula(EnumCM_IOLCalculationFormula enumIOLCalculationFormula)
	{
		/**
		 * Retrieves the value for CodingSchemeDesignator, CodingSchemeVersion and Code Meaning and 
		 * sets the Code Value according to Code Meaning.
		 */
		this.strCodeMeaning = enumIOLCalculationFormula.getValue();
		this.strCodingSchemeDesignator = EnumCodingSchemeDesignator.DCM.getValue();
		
		/**
		 * set code Value
		 */
		setCodeValue(enumIOLCalculationFormula);
	}
}
